import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";

/* eslint-disable react/no-direct-mutation-state */
import React, { useState, Fragment } from 'react';
import { withStyles } from '@material-ui/core/styles';
import Minutes from '../minutes-select';
import Hour from '../hour-select';
import LabelBox from '../labelBox';
import styles from '../cron-builder.styl';

var DailyCron = function DailyCron(_ref) {
  var classes = _ref.classes,
      value = _ref.value,
      _onChange = _ref.onChange,
      translateFn = _ref.translate;

  var _useState = useState(value[3] !== '?'),
      _useState2 = _slicedToArray(_useState, 2),
      every = _useState2[0],
      setEvery = _useState2[1];

  var onDayChange = function onDayChange(e) {
    if (!e.target.value || e.target.value > 0 && e.target.value < 32) {
      //setValue(['0', this.getValueByIndex(1), this.getValueByIndex(1),'*','*','?','*']);
      onValueChange(3, e.target.value ? "1/".concat(e.target.value) : e.target.value);
    }
  };

  var onAtHourChange = function onAtHourChange(e) {
    onValueChange(2, e.target.value);
  };

  var onAtMinuteChange = function onAtMinuteChange(e) {
    onValueChange(1, e.target.value);
  };

  var onValueChange = function onValueChange(cronPosition, input) {
    var val = value;
    val[cronPosition] = input;

    _onChange(JSON.parse(JSON.stringify(val)));
  };

  return /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement(LabelBox, {
    variant: "content"
  }, /*#__PURE__*/React.createElement("input", {
    className: classes.radio,
    type: "radio",
    onChange: function onChange(e) {
      setEvery(true);

      _onChange();
    },
    value: "1",
    name: "DailyRadio",
    checked: every
  }), /*#__PURE__*/React.createElement("span", null, translateFn('Every')), /*#__PURE__*/React.createElement("input", {
    disabled: !every,
    type: "Number",
    maxLength: "2",
    onChange: onDayChange,
    value: value[3].split('/')[1] ? value[3].split('/')[1] : ''
  }), /*#__PURE__*/React.createElement("span", null, translateFn('day(s)'))), /*#__PURE__*/React.createElement(LabelBox, {
    variant: "content"
  }, /*#__PURE__*/React.createElement("input", {
    className: classes.radio,
    onChange: function onChange(e) {
      setEvery(false);

      _onChange(['0', value[1], value[2], '?', '*', 'MON-FRI', '*']);
    },
    type: "radio",
    value: "2",
    name: "DailyRadio",
    checked: !every
  }), /*#__PURE__*/React.createElement("span", null, translateFn('Every week day'))), /*#__PURE__*/React.createElement(LabelBox, {
    variant: "content"
  }, /*#__PURE__*/React.createElement("span", null, translateFn('Start time')), /*#__PURE__*/React.createElement(Hour, {
    onChange: onAtHourChange,
    value: value[2]
  }), /*#__PURE__*/React.createElement(Minutes, {
    onChange: onAtMinuteChange,
    value: value[1]
  })));
};

DailyCron.muiName = 'DailyCron';
export default withStyles(styles)(DailyCron);