import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import React, { useState, Fragment } from 'react';
import { withStyles } from '@material-ui/core/styles';
import Minutes from '../minutes-select';
import Hour from '../hour-select';
import LabelBox from '../labelBox';
import styles from '../cron-builder.styl';

var HourlyCron = function HourlyCron(_ref) {
  var classes = _ref.classes,
      value = _ref.value,
      translateFn = _ref.translate,
      _onChange = _ref.onChange;

  var _useState = useState(value[2].split('/')[1] || value[2] === '*'),
      _useState2 = _slicedToArray(_useState, 2),
      every = _useState2[0],
      setEvery = _useState2[1];

  var onHourChange = function onHourChange(e) {
    if (every && (e.target.value > 0 && e.target.value < 24 || e.target.value === '')) {
      var val = ['0', '0', '*', '*', '*', '?', '*'];
      val[2] = e.target.value ? "0/".concat(e.target.value) : e.target.value;
      val[3] = '1/1';

      _onChange(val);
    }
  };

  var onAtHourChange = function onAtHourChange(e) {
    var val = ['0', value[1], '*', '1/1', '*', '?', '*'];
    val[2] = "".concat(e.target.value);

    _onChange(val);
  };

  var onAtMinuteChange = function onAtMinuteChange(e) {
    var val = ['0', '*', value[2], '1/1', '*', '?', '*'];
    val[1] = "".concat(e.target.value);

    _onChange(val);
  };

  return /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement(LabelBox, {
    variant: "content"
  }, /*#__PURE__*/React.createElement("input", {
    className: classes.radio,
    type: "radio",
    onChange: function onChange(e) {
      setEvery(true);

      _onChange(['0', '0', '0/1', '1/1', '*', '?', '*']);
    },
    checked: every
  }), /*#__PURE__*/React.createElement("span", null, translateFn('Every'), " "), /*#__PURE__*/React.createElement("input", {
    disabled: !every,
    type: "Number",
    onChange: onHourChange,
    value: value[2].split('/')[1] ? value[2].split('/')[1] : ''
  }), /*#__PURE__*/React.createElement("span", null, translateFn('hour(s)'))), /*#__PURE__*/React.createElement(LabelBox, {
    variant: "content"
  }, /*#__PURE__*/React.createElement("input", {
    className: classes.radio,
    type: "radio",
    onChange: function onChange(e) {
      setEvery(false);

      _onChange();
    },
    checked: !every
  }), /*#__PURE__*/React.createElement("span", null, translateFn('At')), /*#__PURE__*/React.createElement(Hour, {
    disabled: every,
    onChange: onAtHourChange,
    value: value[2]
  }), /*#__PURE__*/React.createElement(Minutes, {
    disabled: every,
    onChange: onAtMinuteChange,
    value: value[1]
  })));
};

HourlyCron.muiName = 'HourlyCron';
export default withStyles(styles)(HourlyCron);