import React from 'react';
import { withStyles } from '@material-ui/core/styles';
import LabelBox from '../labelBox';
import styles from '../cron-builder.styl';

var MinutesCron = function MinutesCron(_ref) {
  var classes = _ref.classes,
      handleChange = _ref.onChange,
      value = _ref.value,
      translateFn = _ref.translate;

  var onChange = function onChange(e) {
    if (e.target.value > 0 && e.target.value < 60 || e.target.value === '') {
      var val = ['0', '*', '*', '*', '*', '?', '*'];
      val[1] = e.target.value ? "0/".concat(e.target.value) : val[1];
      handleChange(val);
    }
  };

  if (value && value.length > 1) {
    value = value[1].split('/')[1];
  }

  return /*#__PURE__*/React.createElement(LabelBox, {
    variant: "content"
  }, translateFn('Every'), " ", /*#__PURE__*/React.createElement("input", {
    type: "Number",
    onChange: onChange,
    value: value,
    min: 1,
    max: 60
  }), " ", translateFn('minute(s)'));
};

MinutesCron.defaultProps = {
  onChange: function onChange(value) {
    console.log(value);
  }
};
MinutesCron.muiName = 'MinutesCron';
export default withStyles(styles)(MinutesCron);