import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";

var _this = this;

/* eslint-disable react/no-direct-mutation-state */
import React, { useState, useEffect, Fragment } from 'react';
import { withStyles } from '@material-ui/core/styles';
import Typography from '@material-ui/core/Typography';
import Minutes from '../minutes-select';
import Hour from '../hour-select';
import LabelBox from '../labelBox';
import styles from '../cron-builder.styl';

var MonthlyCron = function MonthlyCron(_ref) {
  var classes = _ref.classes,
      value = _ref.value,
      _onChange = _ref.onChange,
      translateFn = _ref.translate;

  var _useState = useState(0),
      _useState2 = _slicedToArray(_useState, 2),
      every = _useState2[0],
      setEvery = _useState2[1];

  useEffect(function () {
    if (value[3] === 'L') {
      setEvery("2");
    } else if (value[3] === 'LW') {
      setEvery("3");
    } else if (value[3].startsWith('L')) {
      setEvery("4");
    } else {
      setEvery("1");
    }
  }, []);

  var onDayChange = function onDayChange(e) {
    if (parseInt(e.target.value) > 0 && parseInt(e.target.value) <= 31 || e.target.value === "") {
      var val = ['0', value[1] === '*' ? '0' : value[1], value[2] === '*' ? '0' : value[2], value[3], '1/1', '?', '*'];
      val[3] = "".concat(e.target.value);

      _onChange(val);
    }
  };

  var onLastDayChange = function onLastDayChange(e) {
    if (parseInt(e.target.value) >> 0 && parseInt(e.target.value) <= 31 || e.target.value === "") {
      var val = ['0', value[1] === '*' ? '0' : value[1], value[2] === '*' ? '0' : value[2], value[3], '1/1', '?', '*'];
      val[3] = e.target.value === '' ? '' : "L-".concat(e.target.value);

      _onChange(val);
    }
  };

  var onAtHourChange = function onAtHourChange(e) {
    var val = value;
    val[2] = "".concat(e.target.value);

    _onChange(val);
  };

  var onAtMinuteChange = function onAtMinuteChange(e) {
    var val = value;
    val[1] = "".concat(e.target.value);

    _onChange(val);
  };

  return /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement(LabelBox, {
    variant: "content"
  }, /*#__PURE__*/React.createElement("input", {
    className: classes.radio,
    type: "radio",
    onChange: function onChange(e) {
      setEvery(e.target.value);

      _onChange(['0', _this.state.value[1] === '*' ? '0' : value[1], value[2] === '*' ? '0' : value[2], '1', '1/1', '?', '*']);
    },
    value: "1",
    name: "MonthlyRadio",
    checked: every === "1" ? true : false
  }), translateFn('Day'), /*#__PURE__*/React.createElement("input", {
    readOnly: every !== "1",
    type: "number",
    value: value[3],
    onChange: onDayChange
  }), translateFn('of every month(s)')), /*#__PURE__*/React.createElement(LabelBox, {
    variant: "content"
  }, /*#__PURE__*/React.createElement("input", {
    className: classes.radio,
    onChange: function onChange(e) {
      setEvery(e.target.value);

      _onChange(['0', value[1] === '*' ? '0' : value[1], value[2] === '*' ? '0' : value[2], 'L', '*', '?', '*']);
    },
    type: "radio",
    value: "2",
    name: "DailyRadio",
    checked: every === "2" ? true : false
  }), translateFn('Last day of every month')), /*#__PURE__*/React.createElement(LabelBox, {
    variant: "content"
  }, /*#__PURE__*/React.createElement("input", {
    className: classes.radio,
    onChange: function onChange(e) {
      setEvery(e.target.value);

      _onChange(['0', value[1] === '*' ? '0' : value[1], value[2] === '*' ? '0' : value[2], 'LW', '*', '?', '*']);
    },
    type: "radio",
    value: "3",
    name: "DailyRadio",
    checked: every === "3" ? true : false
  }), translateFn('On the last weekday of every month')), /*#__PURE__*/React.createElement(LabelBox, {
    variant: "content"
  }, /*#__PURE__*/React.createElement("input", {
    className: classes.radio,
    type: "radio",
    onChange: function onChange(e) {
      setEvery(e.target.value);

      _onChange(['0', value[1] === '*' ? '0' : value[1], value[2] === '*' ? '0' : value[2], "L-".concat(1), '*', '?', '*']);
    },
    value: "4",
    name: "MonthlyRadio",
    checked: every === "4" ? true : false
  }), /*#__PURE__*/React.createElement("input", {
    readOnly: every !== "4",
    type: "number",
    value: value[3].split('-')[1],
    onChange: onLastDayChange
  }), translateFn('day(s) before the end of the month')), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(Typography, {
    variant: "body1",
    gutterBottom: true
  }, translateFn('Start time'), /*#__PURE__*/React.createElement(Hour, {
    onChange: onAtHourChange,
    value: value[2]
  }), /*#__PURE__*/React.createElement(Minutes, {
    onChange: onAtMinuteChange,
    value: value[1]
  })));
};

MonthlyCron.defaultProps = {
  onChange: function onChange(value) {
    console.log(value);
  }
};
MonthlyCron.muiName = "MonthlyCron";
export default withStyles(styles)(MonthlyCron);