import React, { Fragment } from 'react';
import { withStyles } from '@material-ui/core/styles';
import FormControl from '@material-ui/core/FormControl';
import FormGroup from '@material-ui/core/FormGroup';
import FormControlLabel from '@material-ui/core/FormControlLabel';
import Checkbox from '@material-ui/core/Checkbox';
import Minutes from '../minutes-select';
import Hour from '../hour-select';
import styles from '../cron-builder.styl';
import LabelBox from '../labelBox';
var DoW = {
  MON: "Monday",
  TUE: "Tuesday",
  WED: "Wednesday",
  THU: "Thursday",
  FRI: "Friday",
  SAT: "Saturday",
  SUN: "Sunday"
};

var WeeklyCron = function WeeklyCron(_ref) {
  var classes = _ref.classes,
      value = _ref.value,
      onChange = _ref.onChange,
      translateFn = _ref.translate;

  var onAtHourChange = function onAtHourChange(e) {
    var val = value;
    val[0] = '0';
    val[2] = "".concat(e.target.value);
    onChange(JSON.parse(JSON.stringify(val)));
  };

  var onAtMinuteChange = function onAtMinuteChange(e) {
    var val = value;
    val[0] = '0';
    val[1] = "".concat(e.target.value);
    onChange(JSON.parse(JSON.stringify(val)));
  };

  var onCheck = function onCheck(e) {
    var val = value;
    val[0] = '0';

    if (e.target.checked) {
      onDayChecked(val, e);
    } else {
      onDayUnChecked(val, e);
    }

    onChange(JSON.parse(JSON.stringify(val)));
  };

  var onDayChecked = function onDayChecked(val, e) {
    val[2] = "".concat(val[2]).split('/').length > 1 ? '0' : val[2].toString();
    val[3] = '?';
    val[4] = '*';

    if (val[5] === '*' || val[5] === '?' || val[5] === 'MON-FRI') {
      val[5] = e.target.value;
    } else {
      val[5] = val[5] + '!' + e.target.value;
    }
  };

  var onDayUnChecked = function onDayUnChecked(val, e) {
    val[5] = val[5].split('!');

    if (val[5].length > 1) {
      val[5].splice(val[5].indexOf(e.target.value), 1);
      val[5] = val[5].toString().replace(/,/g, '!');
    } else {
      val[5] = '*';
    }
  };

  var Checkboxes = Object.keys(DoW).reduce(function (result, key, i) {
    result[i % result.length].push( /*#__PURE__*/React.createElement(FormControlLabel, {
      control: /*#__PURE__*/React.createElement(Checkbox, {
        value: key,
        checked: value[5].search(key) !== -1,
        onChange: onCheck,
        name: DoW[key]
      }),
      label: translateFn(DoW[key])
    }));
    return result;
  }, [[], [], []]);
  return /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement(LabelBox, {
    variant: "content"
  }, translateFn('Start time'), /*#__PURE__*/React.createElement(Hour, {
    onChange: onAtHourChange,
    value: value[2]
  }), /*#__PURE__*/React.createElement(Minutes, {
    onChange: onAtMinuteChange,
    value: value[1]
  })), /*#__PURE__*/React.createElement(LabelBox, {
    variant: "content"
  }, Checkboxes.map(function (box) {
    return /*#__PURE__*/React.createElement(FormControl, null, /*#__PURE__*/React.createElement(FormGroup, null, box));
  })));
};

WeeklyCron.defaultProps = {
  onChange: function onChange(value) {
    console.log(value);
  }
};
WeeklyCron.muiName = 'WeeklyCron';
export default withStyles(styles)(WeeklyCron);